#include "wrapper.h"

#include "../filters/binarize/filter.h"
#include "../filters/invert/filter.h"
#include "../filters/logic/filter.h"
#include "../filters/merge/filter.h"
#include "../filters/convolution/filter.h"
#include "../filters/lut/lut/filter.h"
#include "../filters/lut/lutxy/filter.h"
#include "../filters/mask/edge/filter.h"
#include "../filters/mask/motion/filter.h"
#include "../filters/mask/hysteresis/filter.h"
#include "../filters/morphologic/expand/filter.h"
#include "../filters/morphologic/inpand/filter.h"
#include "../filters/morphologic/inflate/filter.h"
#include "../filters/morphologic/deflate/filter.h"


using namespace MaskTools;
using namespace MaskTools::Avs25;
using namespace MaskTools::Filters;

extern "C" __declspec(dllexport) const char* __stdcall AvisynthPluginInit2(IScriptEnvironment* env)
{
   AddFilter_T<Binarize::Filter>(env);

   AddFilter_T<Invert::Filter>(env);

   AddFilter_T<Logic::Filter>(env);

   AddFilter_T<Merge::Filter>(env);

   AddFilter_T<Convolution::Filter>(env);

   AddFilter_T<Lut::Single::Filter>(env);
   AddFilter_T<Lut::Dual::Filter>(env);

   AddFilter_T<Mask::Edge::Filter>(env);
   AddFilter_T<Mask::Motion::Filter>(env);
   AddFilter_T<Mask::Hysteresis::Filter>(env);

   AddFilter_T<Morphologic::Expand::Filter>(env);
   AddFilter_T<Morphologic::Inpand::Filter>(env);
   AddFilter_T<Morphologic::Inflate::Filter>(env);
   AddFilter_T<Morphologic::Deflate::Filter>(env);

   return("MaskTools: a set of tools to work with masks");
}
