%INCLUDE "common.asm"

%MACRO MT_MORPHOLOGIC_ROLLED_INSIDE    12
   MT_LOAD_NORMAL          movq  , mm0, esi + %4, ebx, mm6, mm7
   movq                    mm1   , mm0
   %5                      %1    , mm0, esi + %4, ebx, mm6, mm7
   %6                      %1    , mm0, esi + %4, ebx, mm6, mm7
   %3                      mm1   , mm5
   %7                      %1    , mm0, esi + %4, ebx, mm6, mm7
   %8                      %1    , mm0, esi + %4, ebx, mm6, mm7
   %9                      %1    , mm0, esi + %4, ebx, mm6, mm7
   %10                     %1    , mm0, esi + %4, ebx, mm6, mm7
   %11                     %1    , mm0, esi + %4, ebx, mm6, mm7
   %12                     %1    , mm0, esi + %4, ebx, mm6, mm7
   %2                      mm0   , mm1
   movq                    [edi + %4], mm0
%ENDMACRO

%MACRO MT_MORPHOLOGIC_ROLLED     11
   MT_MORPHOLOGIC_ROLLED_INSIDE  %1, %2, %3, 0 , %4, %5, %6, %7, %8, %9, %10, %11
%ENDMACRO

%DEFINE MT_EXPAND_OPERATORS      pmaxub, pminub, paddusb
%DEFINE MT_INPAND_OPERATORS      pminub, pmaxub, psubusb

%MACRO MT_EXPAND_ROLLED          8
   MT_MORPHOLOGIC_ROLLED         MT_EXPAND_OPERATORS, %1, %2, %3, %4, %5, %6, %7, %8
%ENDMACRO

%MACRO MT_INPAND_ROLLED          8
   MT_MORPHOLOGIC_ROLLED         MT_INPAND_OPERATORS, %1, %2, %3, %4, %5, %6, %7, %8
%ENDMACRO

%MACRO MT_MORPHOLOGIC_UNROLLED   11
   MT_MORPHOLOGIC_ROLLED_INSIDE  %1, %2, %3, 0 , %4, %5, %6, %7, %8, %9, %10, %11
   MT_MORPHOLOGIC_ROLLED_INSIDE  %1, %2, %3, 8 , %4, %5, %6, %7, %8, %9, %10, %11
   MT_MORPHOLOGIC_ROLLED_INSIDE  %1, %2, %3, 16, %4, %5, %6, %7, %8, %9, %10, %11
   MT_MORPHOLOGIC_ROLLED_INSIDE  %1, %2, %3, 24, %4, %5, %6, %7, %8, %9, %10, %11
   MT_MORPHOLOGIC_ROLLED_INSIDE  %1, %2, %3, 32, %4, %5, %6, %7, %8, %9, %10, %11
   MT_MORPHOLOGIC_ROLLED_INSIDE  %1, %2, %3, 40, %4, %5, %6, %7, %8, %9, %10, %11
   MT_MORPHOLOGIC_ROLLED_INSIDE  %1, %2, %3, 48, %4, %5, %6, %7, %8, %9, %10, %11
   MT_MORPHOLOGIC_ROLLED_INSIDE  %1, %2, %3, 56, %4, %5, %6, %7, %8, %9, %10, %11
%ENDMACRO

%MACRO MT_EXPAND_UNROLLED        8
   MT_MORPHOLOGIC_UNROLLED       MT_EXPAND_OPERATORS, %1, %2, %3, %4, %5, %6, %7, %8
%ENDMACRO

%MACRO MT_INPAND_UNROLLED        8
   MT_MORPHOLOGIC_UNROLLED       MT_INPAND_OPERATORS, %1, %2, %3, %4, %5, %6, %7, %8
%ENDMACRO

%MACRO MT_MORPHOLOGIC_NEXT_LINE  0
   add                           esi, [esp + .nSrcPad]
   add                           edi, [esp + .nDstPad]
%ENDMACRO

%MACRO MT_MORPHOLOGIC_NEXT_8_PIXELS 0
   add                           esi, 8
   add                           edi, 8
%ENDMACRO

%MACRO MT_MORPHOLOGIC_NEXT_64_PIXELS 0
   add                           esi, 64
   add                           edi, 64
%ENDMACRO

%MACRO MT_MORPHOLOGIC_FUNCTION  2
   MT_SET_STACK            5, esi, edi, ebx, ebp
   .pDst                   PARAM(1)
   .nDstPitch              PARAM(2)
   .pSrc                   PARAM(3)
   .nSrcPitch              PARAM(4)
   .nMaxDeviation          PARAM(5)
   .nWidth                 PARAM(6)
   .nHeight                PARAM(7)
   .nTailWidth             PSTACK(0)
   .nUnrolledWidth         PSTACK(1)
   .nSrcPad                PSTACK(2)
   .nDstPad                PSTACK(3)
   .nHeightCount           PSTACK(4)
   
   movd                    mm5, [esp + .nMaxDeviation]
   punpcklbw               mm5, mm5
   punpcklwd               mm5, mm5
   punpckldq               mm5, mm5
   
   mov                     edi, [esp + .pDst]
   mov                     esi, [esp + .pSrc]
   mov                     ebx, [esp + .nSrcPitch]
   mov                     ebp, [esp + .nDstPitch]
   sub                     esi, ebx                         ; positive offset needed for pitches
   
   mov                     ecx, [esp + .nWidth]
   sub                     ecx, ebx
   neg                     ecx
   mov                     [esp + .nSrcPad], ecx
   mov                     ecx, [esp + .nWidth]
   sub                     ecx, ebp
   neg                     ecx
   mov                     [esp + .nDstPad], ecx
   
   MT_PROCESS_CONVOLUTION  %1, %2, MT_MORPHOLOGIC_NEXT_LINE, MT_MORPHOLOGIC_NEXT_8_PIXELS, MT_MORPHOLOGIC_NEXT_64_PIXELS
   
   MT_REL_STACK
%ENDMACRO