#ifndef __Mt_Clip_H__
#define __Mt_Clip_H__

#include "../common.h"

namespace MaskTools { namespace Clip {

class Clip {
   int nWidth, nHeight;
   int nFrames;
public:
   Clip();
   Clip(int nWidth, int nHeight, int nFrames);
   int width() const;
   int height() const;
   int frame_count() const;
};

typedef enum {
   UNUSED            = 0x00,
   SOURCE            = 0x01, 
   CREATE            = 0x02,
   IN_PLACE          = 0x04,

} Process;

class Input {
   int nOffset;
   int nIdx;
   Process process;

public:
   Input();
   Input(Process process);
   Input(Process process, int nIdx);
   Input(Process process, int nIdx, int nOffset);

   operator bool() const;
   operator Process() const;
   int idx() const { return nIdx; }
   int offset() const { return nOffset; }
};

class Inputs {
   Input clips[4];
public:
   Inputs();
   Inputs(const Input &clip1);
   Inputs(const Inputs &clips);
   Inputs(const Input &clip1, const Input &clip2);
   Inputs(const Input &clip1, const Input &clip2, const Input &clip3);
   Inputs(const Input &clip1, const Input &clip2, const Input &clip3, const Input &clip4);

   bool IsClip(int nIdx) const;
   Input clip(int nIdx) const;
};

/* thanks ticpp for that tips */
Inputs &IPOneFrame();
Inputs &OneFrame();
Inputs &IPTwoFrames();
Inputs &TwoFrames();
Inputs &IPThreeFrames();
Inputs &ThreeFrames();
Inputs &IPTemporalOneFrame();

} }

#endif
