#ifndef __Mt_Binarize_H__
#define __Mt_Binarize_H__

#include "../../common/base/filter.h"

namespace MaskTools { namespace Filters { namespace Binarize {

typedef void(Processor)(Byte *pDst, int nDstPitch, int nThreshold, int nWidth, int nHeight);

class Filter : public MaskTools::Filter
{
   int nThreshold;

protected:
   virtual void ProcessY(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessU(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessV(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

public:
   Filter(const Parameters::Parameters &parameters);

   static String getName();
   static Parameters::Signature getSignature();
   static Clip::Inputs inputClips;
};

Processor upper_c;
Processor lower_c;

extern "C" Processor Binarize_upper8_mmx;
extern "C" Processor Binarize_lower8_mmx;
extern "C" Processor Binarize_upper8_isse;
extern "C" Processor Binarize_lower8_isse;
extern "C" Processor Binarize_upper8_3dnow;
extern "C" Processor Binarize_lower8_3dnow;

} } }

#endif