#ifndef __Mt_Logic_H__
#define __Mt_Logic_H__

#include "../../common/base/filter.h"

namespace MaskTools { namespace Filters { namespace Logic {

typedef void(Processor)(Byte *pDst, int nDstPitch, const Byte *pSrc1, int nSrc1Pitch, int nWidth, int nHeight);

class Filter : public MaskTools::Filter
{

protected:
   virtual void ProcessY(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessU(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessV(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

public:
   Filter(const Parameters::Parameters &parameters);

   static String getName();
   static Parameters::Signature getSignature();
   static Clip::Inputs inputClips;
};

extern Processor *and_c;
extern Processor *or_c;
extern Processor *andn_c;
extern Processor *xor_c;
extern Processor *min_c;
extern Processor *max_c;

extern "C" Processor Logic_and8_mmx;
extern "C" Processor Logic_andn8_mmx;
extern "C" Processor Logic_or8_mmx;
extern "C" Processor Logic_xor8_mmx;
extern "C" Processor Logic_min8_isse;
extern "C" Processor Logic_max8_isse;

extern "C" Processor Logic_andn_mmx;
extern "C" Processor Logic_andnn_mmx;
extern "C" Processor Logic_orn_mmx;
extern "C" Processor Logic_xorn_mmx;
extern "C" Processor Logic_minn_isse;
extern "C" Processor Logic_maxn_isse;

extern "C" Processor Logic_and8_isse;
extern "C" Processor Logic_andn8_isse;
extern "C" Processor Logic_or8_isse;
extern "C" Processor Logic_xor8_isse;

extern "C" Processor Logic_and8_3dnow;
extern "C" Processor Logic_andn8_3dnow;
extern "C" Processor Logic_or8_3dnow;
extern "C" Processor Logic_xor8_3dnow;
extern "C" Processor Logic_min8_3dnow;
extern "C" Processor Logic_max8_3dnow;

} } }

#endif