#ifndef __Mt_Merge_H__
#define __Mt_Merge_H__

#include "../../common/base/filter.h"

namespace MaskTools { namespace Filters { namespace Merge {

typedef void(Processor)(Byte *pDst, int nDstPitch, const Byte *pSrc1, int nSrc1Pitch,
                        const Byte *pSrc2, int nSrc2Pitch, int nWidth, int nHeight);

class Filter : public MaskTools::Filter
{

protected:
   virtual void ProcessY(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessU(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessV(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

public:
   Filter(const Parameters::Parameters &parameters);

   static String getName();
   static Parameters::Signature getSignature();
   static Clip::Inputs inputClips;
};

Processor merge_c;

extern "C" Processor Merge_merge4_mmx;
extern "C" Processor Merge_merge8_mmx;
extern "C" Processor Merge_merge8_isse;
extern "C" Processor Merge_merge8_3dnow;

} } }

#endif