#include "filter.h"

using namespace MaskTools;
using namespace MaskTools::Picture;
using namespace MaskTools::Parameters;
using namespace MaskTools::Constraints;

namespace MaskTools { namespace Filters { namespace Morphologic { namespace Deflate {

Filter::Filter(const Parameters::Parameters &parameters) : Morphologic::Filter(parameters)
{
   /* add the processors */
   addProcessor(Constraints::Processor<PlaneProcessor>(PPlaneProcessor(deflate_c), Constraint(CPU_NONE, 1, 1, 1, 1), 0));
}

String Filter::getName() { return "mt_deflate"; }

Signature Filter::getSignature()
{
   Signature signature;
   signature.push_back(Parameter(CLIP, ""));
   signature.push_back(Parameter(256, "thY"));
   signature.push_back(Parameter(255, "thC"));

   return addDefaultCommons(signature);
}

} } } }