#include "filter.h"
#include "../../../filters/morphologic/functions.h"

using namespace MaskTools;

static inline Byte meanMin(Byte a1, Byte a2, Byte a3, Byte a4, Byte a5, Byte a6, Byte a7, Byte a8, Byte a9)
{
   int nSum = 0, nCount = 0;
   if ( a1 < a5 ) { nSum += a1; nCount++; }
   if ( a2 < a5 ) { nSum += a2; nCount++; }
   if ( a3 < a5 ) { nSum += a3; nCount++; }
   if ( a4 < a5 ) { nSum += a4; nCount++; }
   if ( a6 < a5 ) { nSum += a6; nCount++; }
   if ( a7 < a5 ) { nSum += a7; nCount++; }
   if ( a8 < a5 ) { nSum += a8; nCount++; }
   if ( a9 < a5 ) { nSum += a9; nCount++; }
   return nCount ? nSum / nCount : a5;
}

static inline Byte meanMinThresholded(Byte a1, Byte a2, Byte a3, Byte a4, Byte a5, Byte a6, Byte a7, Byte a8, Byte a9, int nMaxDeviation)
{
   Byte nMeanMin = meanMin(a1, a2, a3, a4, a5, a6, a7, a8, a9);
   if ( a5 - nMeanMin > nMaxDeviation ) nMeanMin = a5 - nMaxDeviation;
   return nMeanMin;
}

namespace MaskTools { namespace Filters { namespace Morphologic { namespace Deflate {

Processor *deflate_c = &generic_c<meanMinThresholded>;

} } } }